Ruby - Bug #12909

TestProcessi#test_execopts_pgroup might fail
11/08/2016 02:13 PM - vo.x (Vit Ondruch)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: ruby 2.4.0dev (2016-11-07 trunk 56664) |Backport: 2.1: REQUIRED, 2.2: DONE, 2.3: DONE
[x86_64-linux]

Description
| am trying to build Ruby in container, using systemd-nspawn. In this environment, the TestProcess#test_execopts_pgroup test fails:

1) Failure:
TestProcess#test_execopts_pgroup [/builddir/build/BUILD/ruby-2.4.0-r56664/test/ruby/test_process.r
b:1847:
Errno::EPERM expected but nothing was raised.

Initially, | thought it must be something wrong, with mock (Fedora build env tool) or something with systemd-nspawn, but as it turns
out, the test suite is probably rather naive. It assumes that 2 cannot be used as a pgid, but apparently it can. I'd say that this line 1
should be more dynamic, but I'm not really sure what it should be (actually it used to be 1, which works for my case, but it probably
breaks for other scenarios).

Please see 2 for the original report, analysis and explanation.

Associated revisions

Revision fb7e6e10393324e2237e242e2d3ceebe3e47¢c675 - 11/10/2016 12:49 AM - nobu (Nobuyoshi Nakada)

test_process.rb: fix pgroup test
e test/ruby/test_process.rb (TestProcess#test_execopts_pgroup):
use dynamically assigned pid for the process group, instead of a
magic number 2. [ruby-core:78051] [Bug #12909]
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@56684 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision fb7e6e10 - 11/10/2016 12:49 AM - nobu (Nobuyoshi Nakada)
test_process.rb: fix pgroup test
e test/ruby/test_process.rb (TestProcess#test_execopts_pgroup):
use dynamically assigned pid for the process group, instead of a
magic number 2. [ruby-core:78051] [Bug #12909]
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@56684 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision a6f510959e409cb32e8da6a0b6417ac6325302eb - 11/11/2016 03:26 PM - nagachika (Tomoyuki Chikanaga)
merge revision(s) 56684: [Backport #12909]
test_process.rb: fix pgroup test

* test/ruby/test_process.rb (TestProcess#test_execopts_pgroup) :

use dynamically assigned pid for the process group, instead of a
magic number 2. [ruby-core:78051] [Bug #12909]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@56714 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision a6f51095 - 11/11/2016 03:26 PM - nagachika (Tomoyuki Chikanaga)
merge revision(s) 56684: [Backport #12909]

test_process.rb: fix pgroup test

* test/ruby/test_process.rb (TestProcess#test_execopts_pgroup) :
https://github.com/ruby/ruby/blob/911f3d95033f54c0e02107873cbb4219e0ba377c/test/ruby/test_process.rb#L184
https://bugzilla.redhat.com/show_bug.cgi?id=1298228

use dynamically assigned pid for the process group, instead of a
magic number 2. [ruby-core:78051] [Bug #12909]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@56714 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision bcfbc2bb1f7f60704ebfa9c2305a76e1a2714946 - 11/11/2016 10:39 PM - U.Nakamura
merge revision(s) 56684: [Backport #12909]

test_process.rb: fix pgroup test

* test/ruby/test_process.rb (TestProcess#test_execopts_pgroup) :

use dynamically assigned pid for the process group, instead of a
magic number 2. [ruby-core:78051] [Bug #12909]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_ 2@56729 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision bcfbc2bb - 11/11/2016 10:39 PM - U.Nakamura
merge revision(s) 56684: [Backport #12909]

test_process.rb: fix pgroup test

* test/ruby/test_process.rb (TestProcess#test_execopts_pgroup) :

use dynamically assigned pid for the process group, instead of a
magic number 2. [ruby-core:78051] [Bug #12909]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_ 2@56729 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 11/09/2016 01:21 AM - nobu (Nobuyoshi Nakada)
- Status changed from Open to Feedback
- Backport changed from 2.1: UNKNOWN, 2.2: UNKNOWN, 2.3: REQUIRED to 2.1: REQUIRED, 2.2: REQUIRED, 2.3: REQUIRED

Does this patch work?

index 3921395..8ad53ac 100644
-—— 1i/test/ruby/test_process.rb
+++ w/test/ruby/test_process.rb
@@ -183,3 +183,7 Q@
assert_raise (ArgumentError) { system(*TRUECOMMAND, :pgroup=>-1) }

= assert_raise (Errno::EPERM) { Process.wait spawn (*TRUECOMMAND, :pgroup=>2) }
IO.popen ([RUBY, '-egets'], 'w') do |f]|

assert_raise (Errno: :EPERM) {

Process.wait spawn (*TRUECOMMAND, :pgroup=>f.pid)
}

end

+ o+ + o+ o+

#2 - 11/09/2016 11:46 AM - vo.x (Vit Ondruch)

Nobuyoshi Nakada wrote:

Does this patch work?

Yep, it works.

#3 - 11/10/2016 12:49 AM - nobu (Nobuyoshi Nakada)
- Status changed from Feedback to Closed

Applied in changeset r56684.

test_process.rb: fix pgroup test

e test/ruby/test_process.rb (TestProcess#test_execopts_pgroup):
use dynamically assigned pid for the process group, instead of a
magic number 2. [ruby-core:78051] [Bug #12909]
#4 - 11/11/2016 03:26 PM - nagachika (Tomoyuki Chikanaga)
- Backport changed from 2.1: REQUIRED, 2.2: REQUIRED, 2.3: REQUIRED to 2.1: REQUIRED, 2.2: REQUIRED, 2.3: DONE

ruby_2_3 r56714 merged revision(s) 56684.

#5 - 11/11/2016 10:39 PM - usa (Usaku NAKAMURA)
- Backport changed from 2.1: REQUIRED, 2.2: REQUIRED, 2.3: DONE to 2.1: REQUIRED, 2.2: DONE, 2.3: DONE

ruby_2_2 r56729 merged revision(s) 56684.
